function QualityFilter()
{
    var defaultColor  = quality.colors[0],
        selectedColor = defaultColor;

    //   
    var events = new NovaEngine.System.EventsHandler(),
        e_OnValueChangeEventName = "value.change";

    this.__defineGetter__("value", function () { return selectedColor; });

    //  
    this.reset = function ()
    {
        changeColor(defaultColor);
    };

    //     
    this.next = function()
    {
        var index = quality.colors.indexOf(selectedColor);

        if(!~index) changeColor(defaultColor);
        else if((index + 1) >= quality.colors.length) changeColor(defaultColor);
        else changeColor(quality.colors[index + 1]);
    };

    //      
    this.onValueChange = function (callback)
    {
        events.ListenEvent(e_OnValueChangeEventName, callback);
    };

    //
    this.removeListener = function (callback)
    {
        events.RemoveEvent(e_OnValueChangeEventName, callback);
    };

    //
    function changeColor(color)
    {
        if(selectedColor != color)
        {
            selectedColor = color;
            events.DispatchEvent(e_OnValueChangeEventName, [selectedColor]);
        }
    }
}