Wpcl.InstantiateClass("", function Rank()
{
    var that = this;

    var experienceStorage = new NovaEngine.System.Storage.LocalStorageItem("rank.experience", LOCAL_STORAGE_ITEM_VALUE_TYPE.INT);
    var eventsHandler = new NovaEngine.System.EventsHandler();

    var experience   = experienceStorage.value;
    var currentLevel = 0;

    var nextRank    = null;
    var currentRank = null;

    var rankObject = Wpcl.Package.GameItems.package.ranks;
    var ranksArray = Object.keys(rankObject).map(function(key){return rankObject[key]; });

    recalculateRank();

    //   
    this.__defineGetter__("Level", function () { return currentLevel; });

    //   
    this.__defineGetter__("Experience", function () { return experience; });

    //  
    this.__defineSetter__("Experience", function (value) {
        experience += parseFloat(value) || 0;
        experienceStorage.value = experience;
        recalculateRank();
    });

    //    
    this.__defineGetter__("IconUrl", function () { return "resources/ranks/" + currentRank.img_src; });

    //   
    this.__defineGetter__("Description", function () { return currentRank.description; });

    //
    this.Reset = function()
    {
        experienceStorage.value = experience = 0;
        recalculateRank();
    };

    this.OnUpdate = function(event)
    {
        eventsHandler.ListenEvent("update", event);
    };

    function recalculateRank() {

        var em = false;
        var cRank = null;
        var nRank = null;

        ranksArray.reduce(function(prev, current, index, array){
            if(prev.experience >= experience && !cRank) {
                cRank = prev;
                nRank = current;
            }
            return current;
        });

        cRank = cRank || ranksArray[ranksArray.length - 1];

        if(cRank != currentRank)
        {
            em = true;
        }

        currentRank  = cRank;
        nextRank     = nRank;
        currentLevel = ranksArray.indexOf(currentRank) + 1;

        if(em) eventsHandler.DispatchEvent("update", [that.IconUrl, currentRank.description]);
    }

});
