NovaEngine.System.Enum("TUTORIAL_CLOSE_TYPE", ["TIME", "TOUCH"]);

Wpcl.InstantiateFunction("Tutorial", function ITutorial(closeType, htmlLayer, pauseTime) {
    var watchedTeg = "watched";
    var tutorial = this;

    var statusStorage = new NovaEngine.System.Storage.LocalStorageItem(
        "tutorial." + this.constructor.name.toLowerCase(),
        LOCAL_STORAGE_ITEM_VALUE_TYPE.STRING);

    var popup,
        removeDelayFunction;

    this.__defineGetter__("closeType", function() { return closeType; });
    this.Show = function()
    {
        if(popup != null) return;

        popup = new NovaEngine.HtmlDocument.HtmlPopup(htmlLayer);
        removeDelayFunction = popup.RemoveDelay;

        popup.SetBackgroundAnimation("novaengine-popup-in", 0.5, "forwards", "ease-in");
        popup.RemoveDelay = null;
        popup.Remove = function()
        {
            popup.SetBackgroundAnimation("novaengine-popup-out", 0.5, "forwards", "ease-in");
            popup = null;
            removeDelayFunction(0.5);
        };

        P_AttachEvents(popup);
        statusStorage.value = watchedTeg;
    };

    this.Hide = function()
    {
        if(!!popup) popup.Remove();
    };

    this.ShowIfNotWatched = function()
    {
        if(statusStorage.value == watchedTeg) return;
        tutorial.Show();
    };

    function P_AttachEvents(popup)
    {
        switch (closeType)
        {
            case TUTORIAL_CLOSE_TYPE.TIME:
                setTimeout(tutorial.Hide, pauseTime * 1000 || 5000);
                break;
            case TUTORIAL_CLOSE_TYPE.TOUCH:
                popup.layer.element.OnTouchClick(tutorial.Hide);
                break;
        }
    }
});