(function() {

    var weaponTemplatePath = NovaEngine.System.Directory.Combine("scripts/Game/Lib/Windows/Game", "Resources", "Weapon.html");
    NovaEngine.System.FileManager.Queue.AddFirst(weaponTemplatePath);

    Wpcl.InstantiateFunction("", function WeaponEntityUI(parentElement, weaponEntity) {

        var that = this;

        weaponEntity.ListenEvent("skin.change", function() {
            that.updateUI();
        });

        this.ui = {};

        this.updateUI = function() {
            that.updateEcoUI();
            that.updatePriceUI();
            that.updateSkinUI();
        };

        this.updateEcoUI    = function() {
            that.ui.click.innerHTML  = Wpcl.Math.AttachSuffix(weaponEntity.details.click,  0);
            that.ui.income.innerHTML = Wpcl.Math.AttachSuffix(weaponEntity.details.income, 0);
            that.ui.count.innerHTML  = weaponEntity.details.count;
        };

        this.updatePriceUI  = function() {
            this.ui.price.innerHTML = Wpcl.Math.AttachSuffix(weaponEntity.details.price, 2);
        };

        this.updateSkinUI = function() {

            var grad = that.ui.grad;

            for(var i = 0; i < grad.classList.length; i++)
            {
                if(!!~grad.classList[i].indexOf('weapon_quality'))
                {
                    grad.classList.remove(grad.classList[i]);
                }
            }

            var skin = weaponEntity._skin;
            var quality = (!!skin ? skin.quality_color : "DEFAULT");

            grad.classList.add('weapon_quality_' + quality + '_gradient');

            that.ui.image.style.backgroundImage = "url("+ weaponEntity.image +")";
            that.ui.name.innerHTML = weaponEntity.name;
            that.ui.skin.innerHTML = weaponEntity.skinName;

        };

        Constructor();
        function Constructor()
        {
            var itemTmpl = NovaEngine.System.FileManager.GetCachedFile(weaponTemplatePath).value;
            var itemLayer = new HtmlLayer(itemTmpl);

            parentElement.appendChild(itemLayer.element);

            that.ui.name   = itemLayer.GetBindedElement('weapon.name');
            that.ui.skin   = itemLayer.GetBindedElement('weapon.skin');
            that.ui.click  = itemLayer.GetBindedElement('weapon.click');
            that.ui.income = itemLayer.GetBindedElement('weapon.income');
            that.ui.count  = itemLayer.GetBindedElement('weapon.count');
            that.ui.price  = itemLayer.GetBindedElement('weapon.price');
            that.ui.image  = itemLayer.GetBindedElement('weapon.image');
            that.ui.grad   = itemLayer.GetBindedElement('weapon.gradient');

            that.ui.price.OnTouchClick(function(){
                if(weaponEntity.buy())
                {
                    that.updatePriceUI();
                    that.updateEcoUI();
                }
            });

            that.updateUI();
        }

    });
})();