(function() {
    var stylePath = NovaEngine.System.Directory.Combine("scripts/Game/Lib/Windows/Auth", "Resources", "Auth.css");
    var templatePath = NovaEngine.System.Directory.Combine("scripts/Game/Lib/Windows/Auth", "Resources", "Auth.html");

    NovaEngine.System.FileManager.Queue.AddFirst(stylePath);
    NovaEngine.System.FileManager.Queue.AddFirst(templatePath);

    Wpcl.InstantiateFunction("Windows", function Auth()
    {
        var tmpl = NovaEngine.System.FileManager.GetCachedFile(templatePath).value;
        var layer = new HtmlLayer(tmpl);

        document.body.appendChild(layer.element);
        NovaEngine.HtmlDocument.HtmlWindow.call(this, layer);

        var actionsList = {};
        var buttonsList = {};

        this.SetTitle = function(value)
        {
            this.GetBindedElement("header.title").innerHTML = value;
        };

        this.SetSubTitle = function(value)
        {
            this.GetBindedElement("header.subtitle").innerHTML = value;
        };

        this.ClearActionsList = function()
        {
            for(var actionItem in actionsList) actionsList[actionItem].Remove();
            for(var actionButton in buttonsList) buttonsList[actionButton].Remove();
        };

        this.AddAction = function(id, title, completeStatus)
        {
            actionsList[id] = new Wpcl.Windows.AuthActionItem(layer, title, completeStatus);

            if(!!completeStatus) actionsList[id].SetCompletedStatus();
            else actionsList[id].SetInProcessStatus();

            return actionsList[id];
        };

        this.AddButton = function(id, title, callback)
        {
            buttonsList[id] = new Wpcl.Windows.AuthActionButton(layer, title, callback);
            return buttonsList[id];
        };

        this.GetAction = function(id)
        {
            return actionsList[id];
        };

        this.GetButton= function(id)
        {
            return buttonsList[id];
        };
    });
    Wpcl.Windows.Auth.prototype = Object.create(NovaEngine.HtmlDocument.HtmlWindow.prototype);
    Wpcl.Windows.Auth.prototype.constructor = NovaEngine.HtmlDocument.HtmlWindow;
})();