(function() {
    var templatePath = NovaEngine.System.Directory.Combine("scripts/Game/Lib/Windows/Auth", "Resources", "Action.html");
    NovaEngine.System.FileManager.Queue.AddFirst(templatePath);

    Wpcl.InstantiateFunction("Windows", function AuthActionItem(layer, title, completeStatus)
    {
        var tmpl = NovaEngine.System.FileManager.GetCachedFile(templatePath).value;
        var layout = new HtmlLayer(tmpl);

        layout.GetBindedElement("description").innerHTML = title;
        layer.GetBindedElement("actions.list").appendChild(layout.element);

        this.SetDescription = function(value)
        {
            layout.GetBindedElement("description").innerHTML = value;
        };

        this.SetCompletedStatus = function ()
        {
            layout.GetBindedElement("icon.loading").style.display = "none";
            layout.GetBindedElement("icon.loaded").style.display = "block";
            layout.GetBindedElement("icon.error").style.display = "none";
        };

        this.SetInProcessStatus = function ()
        {
            layout.GetBindedElement("icon.loading").style.display = "block";
            layout.GetBindedElement("icon.loaded").style.display = "none";
            layout.GetBindedElement("icon.error").style.display = "none";
        };

        this.SetErrorStatus = function (message)
        {
            if(!!message)
            {
                this.SetDescription(message);
            }

            layout.GetBindedElement("icon.loading").style.display = "none";
            layout.GetBindedElement("icon.loaded").style.display = "none";
            layout.GetBindedElement("icon.error").style.display = "block";
        };

        this.Remove = function()
        {
            var parent = layout.element.parentNode;
            if(parent) parent.removeChild(layout.element);
        }
    });
})();