(function(){
    var stylePath = NovaEngine.System.Directory.Combine("scripts/Game/Lib/Windows/Inventory", "Resources", "Inventory.css");
    var templatePath = NovaEngine.System.Directory.Combine("scripts/Game/Lib/Windows/Inventory", "Resources", "Inventory.html");

    NovaEngine.System.FileManager.Queue.AddFirst(stylePath);
    NovaEngine.System.FileManager.Queue.AddFirst(templatePath);

    // BETA
    Wpcl.InstantiateFunction("Windows", function Inventory() {

        var that = this, inventory = this;

        var sliders = [];
        var layer = new HtmlLayer(NovaEngine.System.FileManager.GetCachedFile(templatePath).value);
        var body = layer.GetBindedElement("inventory.body");
        var filterIndicator = layer.GetBindedElement("inventory.filter.selected");

        document.body.appendChild(layer.element);
        NovaEngine.HtmlDocument.HtmlWindow.call(this, layer);

        var m_Collections = [];
        var scrollBlock = false;
        var offset = 0;
        var maxViews = 20;

        var filterApplyCooldown = 1000;
        var filterApplyTimeout = 0;

        var filter = new QualityFilter();
        var previousFilterValue = filter.value;

        function Init() {
            BuildFilterUI();

            layer.GetBindedElement("inventory.title").innerHTML = LP("inventory.title");
            layer.GetBindedElement("inventory.button.close").OnTouchClick(function () {
                Wpcl.windows.Shop.common.stickerSelect.state = false;
                Wpcl.windows.Game.Show();
            });

            var dt = window.innerHeight / 100 * 50;
            body.addEventListener("scroll", function () {
                var maxScroll = body.scrollHeight - body.offsetHeight;

                if (body.scrollTop + dt >= maxScroll)
                    DrawNextSliders();
            });
        }

        that.OnOpen(function () {
            clearTimeout(filterApplyTimeout);
            that.rebuildAllSliders();
            filter.reset();
            SlidersApplyFilter();
        });
        that.OnClose(function () {
            clearTimeout(filterApplyTimeout);
        });

        this.inspector = new Wpcl.Windows.InventoryInspector(layer.element);

        this.rebuildAllSliders = function () {

            for (var i in sliders)
                sliders[i].remove();

            sliders = [];
            m_Collections = [];

            scrollBlock = false;
            offset = 0;

            //
            var collections = Wpcl.Player.weapons._data;

            for (var o in collections)
                for (var c in collections[o])
                    m_Collections.push(collections[o][c]);

            //m_Collections = Math.arrayShuffle(m_Collections);

            DrawNextSliders();
        };

        Init();

        function BuildFilterUI()
        {
            var filterNode = layer.GetBindedElement("filter");
            var filterButtonNode = layer.GetBindedElement("filter.button");

            filterNode.style.display = "block";

            filterButtonNode.OnTouchClick(function () {
                filter.next();
                body.style.opacity = "0.3";

                clearTimeout(filterApplyTimeout);
                filterApplyTimeout = setTimeout(function() {
                    body.style.opacity = "1";
                    if(previousFilterValue != filter.value) SlidersApplyFilter();
                }, filterApplyCooldown);
            });

            changeButtonColor(filter.value);
            filter.onValueChange(changeButtonColor);

            function changeButtonColor(color)
            {
                filterButtonNode.style.backgroundColor = "#" + color;
            }
        }

        function SlidersApplyFilter()
        {
            var isFirst = true;
            previousFilterValue = filter.value;
            that.rebuildAllSliders();
        }

        function DrawNextSliders()
        {
            if(scrollBlock) return;

            var m_Skin, m_Slider;
            var iteratorStatus = true;
            var index = maxViews * offset;
            var indexCollection = index;
            var m = index + maxViews;

            while(iteratorStatus) {
                if(index >= m || !m_Collections[indexCollection]) {
                    iteratorStatus = false;
                    continue;
                }

                m_Skin = Wpcl.Package.GameItems.package.weapons.skins[m_Collections[indexCollection].hash_id];
                if(!m_Skin) {
                    indexCollection++;
                    continue;
                }

                m_Slider = new Wpcl.Windows.InventorySlider(m_Collections[indexCollection], body, (!index && !offset) ? "big" : "normal");
                sliders.push(m_Slider);
                indexCollection++;

                if(filter.value != quality.colors.default && filter.value != m_Slider.quality)
                   m_Slider.hide();
                else index++;
            }

            offset++;
            if(offset * maxViews >= m_Collections.length) scrollBlock = true;
        }
        
    });
    Wpcl.Windows.Inventory.prototype = Object.create(NovaEngine.HtmlDocument.HtmlWindow.prototype);
    Wpcl.Windows.Inventory.prototype.constructor = NovaEngine.HtmlDocument.HtmlWindow;
})();