(function() {
    var inventoryItemTemplatePath = NovaEngine.System.Directory.Combine("scripts/Game/Lib/Windows/Inventory", "Resources", "InventoryItem.html");

    NovaEngine.System.FileManager.Queue.AddFirst(inventoryItemTemplatePath);
    Wpcl.InstantiateFunction("Windows", function InventorySlider(collection, parent, viewStyle)
    {
        var that = this;
        var stickers =  Wpcl.Package.GameItems.package.stickers;

        var itemTemplateText = NovaEngine.System.FileManager.GetCachedFile(inventoryItemTemplatePath ).value;
        var sliderNode = new HtmlLayer(itemTemplateText);

        var weaponsImageNode        = sliderNode.getBind('skin');
        var weaponsNameNode         = sliderNode.getBind('name');
        var weaponsSkinNameNode     = sliderNode.getBind('skin.name');
        var qualityColorNode        = sliderNode.getBind('quality.color');

        var sticker = sliderNode.getBind('stickers');
        var stickerSlot1 = sliderNode.getBind('sticker1');
        var stickerSlot2 = sliderNode.getBind('sticker2');
        var stickerSlot3 = sliderNode.getBind('sticker3');

        var Directory = NovaEngine.System.Directory;

        var skin = undefined,
            original = undefined;

        Initialize();
        InitializeEvents();

        this.remove = function()
        {
            if(!!parent && !!sliderNode.element.parentElement)
                parent.removeChild(sliderNode.element);
        };

        this.__defineGetter__("quality", function () {
            var skin = Wpcl.Package.GameItems.package.weapons.skins[collection.hash_id];
            if(!skin) return quality.colors.default;
            return skin.quality_color.toUpperCase();
        });

        this.show = sliderNode.show;
        this.hide = sliderNode.hide;
        this.__defineGetter__("element", function () { return sliderNode.element; });

        function Initialize()
        {
            skin = Wpcl.Package.GameItems.package.weapons.skins[collection.hash_id];
            if(!skin) return;

            original = Wpcl.Package.GameItems.package.weapons.originals[skin.hash_name];
            if(!original) return;

            parent.appendChild(sliderNode.element);
            sliderNode.element.classList.add('scroller_size_' + (viewStyle == "big" ? "rect" : "square"));

            weaponsNameNode.innerHTML = (skin.stattrak ? "<i class='stattrak'>ST™</i>" : "") + original.name;
            weaponsSkinNameNode.innerHTML = skin.name;

            qualityColorNode.style.background = "#" + skin.quality_color;

            weaponsImageNode.style.backgroundImage =
                "url(" + Directory.Combine(APP_ENV.entities_images_dir, skin.image) + ")";

            DrawSticker(stickerSlot1, collection.sticker1);
            DrawSticker(stickerSlot2, collection.sticker2);
            DrawSticker(stickerSlot3, collection.sticker3);
        }

        function InitializeEvents()
        {
            sliderNode.element.OnTouchClick(function() {
                // Обычный просмотр
                if(!Wpcl.windows.Shop.common.stickerSelect.state) {
                    Wpcl.windows.Inventory.inspector.inspect(collection);
                    Wpcl.windows.Inventory.inspector.show();
                }
                // Наклеить наклейку
                else {
                    var confirmMessage = LP("combine.sticker.uwant1")
                        + Wpcl.windows.Shop.common.stickerSelect.data.name
                        + LP("combine.sticker.uwant2")
                        + (Wpcl.Math.AttachSuffix(Wpcl.windows.Shop.common.stickerSelect.data.price / 100, 2))
                        + LP("combine.sticker.uwant3")
                        +  original.name + " | " + skin.name;

                    if(confirm(confirmMessage))
                    {
                        var p_wait = new Wpcl.Popup.Wait();
                        Wpcl.Api.Methods.StickerBuy({
                            uwid: collection.uwid,
                            shid: Wpcl.windows.Shop.common.stickerSelect.data.hash_id
                        }, function(response) {
                            p_wait.Remove();

                            var status = response.status;
                            if(status == 200) {
                                response = response.response;

                                // Обновить данные в weapons
                                Wpcl.Player.weapons.remove(original.hash_name, collection.uwid);
                                Wpcl.Player.weapons.insert(original.hash_name, {
                                    uwid        : response.uwid,
                                    hash_id     : response.hash_id,
                                    sticker1    : response.sticker1,
                                    sticker2    : response.sticker2,
                                    sticker3    : response.sticker3
                                });
                                Wpcl.windows.Game.entities.rebuild(original.hash_name);

                                // Сохранение данных
                                Wpcl.Account.syncHash = response.sync_hash;
                                Wpcl.Player.Cash.Set(response.cash);
                                Wpcl.Player.RecalculateStats();

                                // Переход в магазин
                                Wpcl.windows.Shop.common.stickerSelect.state = false;
                                Wpcl.windows.Shop.Show();
                            } else if(status == 768) {
                                alert(LP("marketplace.slots.filled"));
                            } else {
                                alert(LP("common.error.unknown"));
                            }
                        });
                    }
                }
            });
        }

        function DrawSticker(htmlSlot, stickerID)
        {
            if(!stickerID || !htmlSlot)
            {
                htmlSlot.style.display = "none";
                return;
            }

            var stickerData = stickers[stickerID];
            if(!stickerData)
            {
                htmlSlot.style.display = "none";
                return;
            }

            htmlSlot.style.backgroundImage = "url(" + Directory.Combine(APP_ENV.entities_images_dir, stickerData.image) + ")";
            htmlSlot.style.display = "inline-block";
        }
    });
})();