(function() {
    var touchClickTresholder = 10;

    //    
    HTMLElement.prototype.OnTouchStart = function(action, type) {
        //
        this.addEventListener('touchstart', action, type || false);
    };

    //    
    HTMLElement.prototype.OnTouchEnd = function(action, type) {
        //
        this.addEventListener('touchend', action, type || false);
    };

    //    
    HTMLElement.prototype.OnTouchClick = function(action, type) {

        //      
        if(!action || !Function.prototype.isPrototypeOf(action)) return;

        var touchStartStatus = false;
        var s_TapX = 0,
            s_TapY = 0;

        var e_TapX = 0,
            e_TapY = 0;

        //  
        this.addEventListener('touchstart', function(e) {

            s_TapX = e_TapX = e.touches[0].screenX,
                s_TapY = e_TapY = e.touches[0].screenY;

            touchStartStatus = true;

        }, type || false);

        this.addEventListener('touchmove', function(e) {

            e_TapX = e.touches[0].screenX,
                e_TapY = e.touches[0].screenY;

            touchStartStatus = true;

        }, type || false);

        //  
        this.addEventListener('touchend', function(e) {

            if(Math.abs(s_TapX - e_TapX) > touchClickTresholder) return;
            if(Math.abs(s_TapY - e_TapY) > touchClickTresholder) return;

            action();

        }, type || false);
    };

    HTMLElement.prototype.OnTouchSwap = function(action, type) {

        //      
        if(!action || !Function.prototype.isPrototypeOf(action)) return;

        var touchStartStatus = false;
        var s_TapX = 0,
            s_TapY = 0;

        var e_TapX = 0,
            e_TapY = 0;

        //  
        this.addEventListener('touchstart', function(e) {

            s_TapX = e_TapX = e.touches[0].screenX,
                s_TapY = e_TapY = e.touches[0].screenY;

            touchStartStatus = true;

        }, type || false);

        this.addEventListener('touchmove', function(e) {

            e_TapX = e.touches[0].screenX,
                e_TapY = e.touches[0].screenY;

            touchStartStatus = true;

        }, type || false);

        //  
        this.addEventListener('touchend', function(e) {
            var sx = s_TapX - e_TapX;
            var sy = s_TapY - e_TapY;

            var stx = Math.abs(sx) > touchClickTresholder;
            var sty = Math.abs(sy) > touchClickTresholder;

            if(stx || sty) {
                action({
                    x: stx ? (Math.abs(sx) * -1 / sx) : 0,
                    y: sty ? (Math.abs(sy) * -1 / sy) : 0
                });
            }
        }, type || false);

    }
})();