var Color = DeclareClass(function (r, g, b, a) {
    var _r = 0, _g = 0, _b = 0, _a = 0;


    this.__defineGetter__("r", function () { return _r; });
    this.__defineGetter__("g", function () { return _g; });
    this.__defineGetter__("b", function () { return _b; });
    this.__defineGetter__("a", function () { return _a; });

    this.__defineSetter__("r", function (v) {
        if(typeof v != "number") return;
        _r = Math.ceil(Math.clamp(v, 0, 255));
    });
    this.__defineSetter__("g", function (v) {
        if(typeof v != "number") return;
        _g = Math.ceil(Math.clamp(v, 0, 255));
    });
    this.__defineSetter__("b", function (v) {
        if(typeof b != "number") return;
        _b = Math.ceil(Math.clamp(v, 0, 255));
    });
    this.__defineSetter__("a", function (v) {
        if(typeof a != "number") return;
        _a = Math.clamp(v, 0, 1);
    });

    this.__defineGetter__("hex", function () {
        return numberToHex(_r) + numberToHex(_g) + numberToHex(_b);
    });

    this.r = r;
    this.g = g;
    this.b = b;
    this.a = a;

    function numberToHex(value) {
        value = value.toString(16);
        if(value.length == 1) value = "0" + value;
        return value;
    }
});
Color.prototype.lerp = function (colorA, colorB, t) {
    return new Color(
        Math.ceil(Math.lerp(colorA.r, colorB.r, t)),
        Math.ceil(Math.lerp(colorA.g, colorB.g, t)),
        Math.ceil(Math.lerp(colorA.b, colorB.b, t)),
        Math.lerp(colorA.a, colorB.a, t)
    );
};