(function() {
    NovaEngine.InstantiateFunction("System", function Enum(name, types) {
        if(typeof name != "string")
        {
            console.error("Enum Error. name arg is not string");
            return;
        }

        if(!Object.prototype.isPrototypeOf(types))
        {
            console.error("Enum Error. types arg is not array/object");
            return;
        }

        if(!!window[name])
        {
            console.error("Enum Error. object with name: ", name, " already exists");
            return;
        }

        if(Array.isArray(types))
        {
            var typesObj = {};
            types.forEach(function(key, index) {
                typesObj[key] = index;
            });
            types = typesObj;
        }

        for(var key in types)
        {
            types[key] = {
                value: types[key],
                enumerable: false,
                configurable: false,
                writable: false
            }
        }

        Object.defineProperty(window, name, {
            enumerable: false,
            configurable: false,
            writable: false,
            value: {}
        });
        Object.defineProperties(window[name], types);

    });
})();