NovaEngine.InstantiateFunction("System", function EventsHandler()
{
    var events = {};

    this.ListenEvent = function(eventID, eventFunc)
    {
        if(!Function.prototype.isPrototypeOf(eventFunc)) return;
        if(!events[eventID]) events[eventID] = [];
        events[eventID].push(eventFunc);
    };

    this.RemoveEvent = function(eventID, eventFunc)
    {
        if(!Function.prototype.isPrototypeOf(eventFunc)) return;
        if(!events[eventID]) return;
        events[eventID].splice(events[eventID].indexOf(eventFunc), 1);
    };

    this.DispatchEvent = function(eventID, parameters)
    {
        if(!events[eventID]) return;
        for(var key in events[eventID]) events[eventID][key].apply(null, parameters);
    };
});