Math.Clamp = function(a, b, c)
{
    return Math.max(b, Math.min(c, a));
};

Math.randomRangeInt = function(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
};

Math.bool2int = function(bool) {
    return !!bool ? 1 : 0;
};

Math.arrayShuffle = function(array) {
    var counter = array.length;
    var index, temp;

    // While there are elements in the array
    while (counter > 0)
    {
        // Pick a random index
        index = Math.floor(Math.random() * counter);

        // Decrease counter by 1
        counter--;

        // And swap the last element with it
        temp = array[counter];
        array[counter] = array[index];
        array[index] = temp;
    }

    return array;
};

Math.lerp = function (a, b, t) {
    return a * (1 - t) + b * t;
};

Math.clamp = function (value, min, max) {
    if(value < min) return min;
    if(value > max) return max;
    return value;
};

Math.weightedRandom = function (values, weights) {
    var total = weights.reduce(function (a, b) {return a + b; });
    var num = Math.randomRangeInt(1, total);
    var n = 0;

    for(var i in values) {
        n += weights[i];
        if (n >= num) return values[i];
    }
};