NovaEngine.InstantiateFunction("System", function Value(
    tag,
    defaultValue,
    storageType,
    useLocalStorage,
    useEncrypt,
    autosaveTimeSeconds,
    useAutosave,
    useChangeSave
)
{
    //
    var that  = this;
    var value = defaultValue;

    var eventsHandler = new NovaEngine.System.EventsHandler();
    var storage = new NovaEngine.System.Storage.LocalStorageItem(tag, storageType, useEncrypt);

    if(useAutosave)  setInterval(autosaveTimeSeconds * 1000, P_Save);
    if(useLocalStorage) value = storage.value || defaultValue;

    this.Set = function(v)
    {
        value = v;
        P_DispatchValueChange();
    };

    this.Get = function()
    {
        return value;
    };

    this.Inc = function(v)
    {
        value += v;
        P_DispatchValueChange();
    };

    this.Dec = function(v)
    {
        value -= v;
        P_DispatchValueChange();
    };

    this.ForceSave = function()
    {
        storage.value = value;
    };

    this.Reset = function()
    {
        that.Set(0);
        that.ForceSave();
    };

    this.OnChange = function(eventFunc)
    {
        eventsHandler.ListenEvent("change", eventFunc);
    };

    function P_DispatchValueChange()
    {
        eventsHandler.DispatchEvent("change", [value]);
    }

    function P_Save()
    {
        if(!useLocalStorage) return;
        storage.value = value;
    }
});